/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package TexturedSphere;

import javax.swing.event.MouseInputAdapter;
import java.awt.event.MouseEvent;
import javax.swing.*;
import java.awt.*;


/**
 * Moue handler class that allows the user to rotate and zoom on the model
 * 
 * 
 */
public class MouseHandler extends MouseInputAdapter {
    private Renderer renderer;

    /**
     * Creates a new instance of the moouse handler
     * 
     * @param renderer
     */
    public MouseHandler(Renderer renderer) {
        this.renderer = renderer;
    }


    /**
     * Handles the mouse click events
     * 
     * @param e
     */
    public void mouseClicked(MouseEvent e) {
        if (SwingUtilities.isRightMouseButton(e)) {

        }
    }


    /**
     * Handles the mouse press events
     * 
     * @param mouseEvent
     */
    public void mousePressed(MouseEvent mouseEvent) {
        if (SwingUtilities.isLeftMouseButton(mouseEvent)) {
            renderer.startDrag(mouseEvent.getPoint());
        } else if (SwingUtilities.isMiddleMouseButton(mouseEvent)) {
            renderer.startZoom(mouseEvent.getPoint());
        }
    }


    /**
     * Handles the mouse drag events
     * 
     * @param mouseEvent
     */
    public void mouseDragged(MouseEvent mouseEvent) {
        if (SwingUtilities.isLeftMouseButton(mouseEvent)) {
            renderer.drag(mouseEvent.getPoint());
        } else if (SwingUtilities.isMiddleMouseButton(mouseEvent)) {
            renderer.zoom(mouseEvent.getPoint());
        }
    }
}
